package com.virtual.plat.server.rs.vm;

import com.extjs.gxt.ui.client.data.BaseModelData;
import com.extjs.gxt.ui.client.data.ModelData;
import com.virtual.common.AppException;
import com.virtual.common.StringManager;
import com.virtual.plat.server.backuphistory.BackupHistoryMgr;
import com.virtual.plat.server.common.CommonMgr;
import com.virtual.plat.server.entity.BackupHistory;
import com.virtual.plat.server.entity.Host;
import com.virtual.plat.server.entity.Organization;
import com.virtual.plat.server.entity.PublicCloud;
import com.virtual.plat.server.entity.QueryConfig;
import com.virtual.plat.server.entity.User;
import com.virtual.plat.server.entity.UserGroup;
import com.virtual.plat.server.host.HostMgr;
import com.virtual.plat.server.organize.OrganizationMgr;
import com.virtual.plat.server.publiccloud.PublicCloudMgr;
import com.virtual.plat.server.publiccloud.PublicCloudUtils;
import com.virtual.plat.server.restore.BackupAndRestoreHandler;
import com.virtual.plat.server.rs.RestUtils;
import com.virtual.plat.server.rs.common.ValidateParams;
import com.virtual.plat.server.rs.entity.RsCommList;
import com.virtual.plat.server.rs.message.entity.RsTaskMsg;
import com.virtual.plat.server.rs.vm.entity.RsDesktopParam;
import com.virtual.plat.server.rs.vm.entity.RsDomain;
import com.virtual.plat.server.rs.vm.entity.RsDomainForBackUp;
import com.virtual.plat.server.rs.vm.entity.RsDomainForRestore;
import com.virtual.plat.server.rs.vm.entity.RsSnapshot;
import com.virtual.plat.server.rs.vm.func.RsDomainMgr;
import com.virtual.plat.server.storage.StorageHandler;
import com.virtual.plat.server.user.UserMgr;
import com.virtual.plat.server.user.UserUtils;
import com.virtual.plat.server.virtualhost.DomainHandler;
import com.virtual.plat.server.virtualhost.DomainMgr;
import com.virtual.plat.server.virtualhost.DomainUtils;
import com.virtual.plat.server.vm.vmware.VMwareConnectionManager;
import com.virtual.plat.server.vmworkflow.VmWorkflowMgr;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Iterator;
import java.util.List;
import java.util.Set;
import javax.annotation.Resource;
import javax.annotation.security.RolesAllowed;
import javax.servlet.http.HttpServletRequest;
import javax.ws.rs.Consumes;
import javax.ws.rs.DELETE;
import javax.ws.rs.GET;
import javax.ws.rs.POST;
import javax.ws.rs.PUT;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;
import javax.ws.rs.QueryParam;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MultivaluedMap;
import javax.ws.rs.core.Response;
import javax.ws.rs.core.SecurityContext;
import javax.ws.rs.core.UriInfo;
import javax.ws.rs.core.Response.ResponseBuilder;
import org.apache.commons.lang.StringUtils;
import org.springframework.stereotype.Service;

@Service
@Path("/vm")
@Consumes({"application/xml", "application/json"})
@Produces({"application/xml", "application/json"})
public class DomainResource {

   private static StringManager sm = StringManager.getManager("com.virtual.plat.server.rs.common");
   private StringManager storageSm = StringManager.getManager(StorageHandler.class);
   @Context
   private UriInfo uriInfo;
   @Context
   private SecurityContext sc;
   @Context
   private HttpServletRequest req;
   @Resource
   private RsDomainMgr rsDomainMgr;
   @Resource
   private BackupHistoryMgr backupHistoryMgr;
   @Resource
   private DomainHandler domainHandler;
   @Resource
   private VMwareConnectionManager vmwareConnManager = null;
   @Resource
   private VmWorkflowMgr vmWorkflowMgr = null;
   @Resource
   private OrganizationMgr organizationMgr;
   @Resource
   private PublicCloudMgr publicCloudMgr;
   @Resource
   private DomainMgr domainMgr;
   @Resource
   private HostMgr hostMgr;
   @Resource
   private UserMgr userMgr = null;
   @Resource
   private CommonMgr commonMgr = null;
   @Resource
   private BackupAndRestoreHandler backupHandler = null;
   @Resource
   private StorageHandler storageHandler;


   @GET
   @Path("/template/netAndStorage")
   @RolesAllowed({"VMC-PLAT-ROLE_RSCLIENT"})
   public RsDomain getTempNetAndStorage() {
      MultivaluedMap var1;
      QueryConfig var2 = RestUtils.queryParamToQueryInfo(var1 = this.uriInfo.getQueryParameters());
      Iterator var3 = var1.keySet().iterator();

      while(var3.hasNext()) {
         String var4 = (String)var3.next();
         Long var5;
         if("orgId".equals(var4)) {
            var5 = ValidateParams.parseLong((String)var1.getFirst(var4), false, "org.id.value.error");
            var2.addRestriction(var4, var5);
         } else if("id".equals(var4)) {
            var5 = ValidateParams.parseLong((String)var1.getFirst(var4), false, "id.value.error");
            var2.addRestriction(var4, var5);
         }
      }

      return this.rsDomainMgr.queryTempNetAndStorage(var2);
   }

   @GET
   @Path("/domain/netAndStorage")
   @RolesAllowed({"VMC-PLAT-ROLE_RSCLIENT"})
   public RsDomain getDomainNetAndStorage() {
      MultivaluedMap var1;
      QueryConfig var2 = RestUtils.queryParamToQueryInfo(var1 = this.uriInfo.getQueryParameters());
      Iterator var3 = var1.keySet().iterator();

      while(var3.hasNext()) {
         String var4 = (String)var3.next();
         Long var5;
         if("orgId".equals(var4)) {
            var5 = ValidateParams.parseLong((String)var1.getFirst(var4), false, "org.id.value.error");
            var2.addRestriction(var4, var5);
         } else if("id".equals(var4)) {
            var5 = ValidateParams.parseLong((String)var1.getFirst(var4), false, "id.value.error");
            var2.addRestriction(var4, var5);
         }
      }

      return this.rsDomainMgr.queryDomainNetAndStorage(var2);
   }

   @GET
   @Path("/domain/getUniqueKey/{id : \\d+}")
   @RolesAllowed({"VMC-PLAT-ROLE_RSCLIENT"})
   public String getUniqueKey(@PathParam("id") Long var1) {
      return DomainUtils.getUniqueKeyByDomainId(var1, this.domainMgr);
   }

   @GET
   @Path("/network")
   @RolesAllowed({"VMC-PLAT-ROLE_RSCLIENT"})
   public Response getDomainNetwork() {
      MultivaluedMap var1;
      QueryConfig var2 = RestUtils.queryParamToQueryInfo(var1 = this.uriInfo.getQueryParameters());
      Iterator var3 = var1.keySet().iterator();

      while(var3.hasNext()) {
         String var4 = (String)var3.next();
         Long var5;
         if("orgId".equals(var4)) {
            var5 = ValidateParams.parseLong((String)var1.getFirst(var4), false, "org.id.value.error");
            var2.addRestriction(var4, var5);
         } else if("id".equals(var4)) {
            var5 = ValidateParams.parseLong((String)var1.getFirst(var4), false, "id.value.error");
            var2.addRestriction(var4, var5);
         } else if("userId".equals(var4)) {
            var5 = ValidateParams.parseLong((String)var1.getFirst(var4), false, "user.id.value.error");
            var2.addRestriction(var4, var5);
         }
      }

      List var6 = this.rsDomainMgr.getDomainNetwork(var2);
      return Response.ok(new RsCommList(var6)).build();
   }

   @GET
   @Path("deskTop/{id : \\d+}")
   @RolesAllowed({"VMC-PLAT-ROLE_RSCLIENT"})
   public RsDesktopParam getDesktopParam(@PathParam("id") Long var1) {
      if(var1 == null) {
         throw new AppException(16, new Object[]{sm.getString("domain.id.is.null")});
      } else {
         return this.rsDomainMgr.queryDesktopParam(var1);
      }
   }

   @PUT
   @Path("start")
   @RolesAllowed({"VMC-PLAT-ROLE_RSCLIENT"})
   public RsTaskMsg startDomain(@QueryParam("id") Long var1, @QueryParam("orgId") Long var2, @QueryParam("domainName") String var3) {
      if(var1 == null) {
         throw new AppException(16, new Object[]{sm.getString("domain.id.is.null")});
      } else {
         RestUtils.checkNullParam(var2, "orgId", sm);
         RestUtils.checkNullParam(var3, "domainName", sm);
         String var4 = this.sc.getUserPrincipal().getName();
         String var5 = this.req.getRemoteAddr();
         return this.rsDomainMgr.startDomain(var1, var2, var3, var4, var5);
      }
   }

   @PUT
   @Path("stop")
   @RolesAllowed({"VMC-PLAT-ROLE_RSCLIENT"})
   public RsTaskMsg stopDomain(@QueryParam("id") Long var1, @QueryParam("orgId") Long var2, @QueryParam("domainName") String var3) {
      if(var1 == null) {
         throw new AppException(16, new Object[]{sm.getString("domain.id.is.null")});
      } else {
         RestUtils.checkNullParam(var2, "orgId", sm);
         RestUtils.checkNullParam(var3, "domainName", sm);
         String var4 = this.sc.getUserPrincipal().getName();
         String var5 = this.req.getRemoteAddr();
         return this.rsDomainMgr.shutdownDomain(var1, var2, var3, var4, var5);
      }
   }

   @PUT
   @Path("powerOff")
   @RolesAllowed({"VMC-PLAT-ROLE_RSCLIENT"})
   public RsTaskMsg destroyDomain(@QueryParam("id") Long var1, @QueryParam("orgId") Long var2, @QueryParam("domainName") String var3) {
      if(var1 == null) {
         throw new AppException(16, new Object[]{sm.getString("domain.id.is.null")});
      } else {
         RestUtils.checkNullParam(var2, "orgId", sm);
         RestUtils.checkNullParam(var3, "domainName", sm);
         String var4 = this.sc.getUserPrincipal().getName();
         String var5 = this.req.getRemoteAddr();
         return this.rsDomainMgr.destroyDomain(var1, var2, var3, var4, var5);
      }
   }

   @PUT
   @Path("pause")
   @RolesAllowed({"VMC-PLAT-ROLE_RSCLIENT"})
   public RsTaskMsg pauseDomain(@QueryParam("id") Long var1, @QueryParam("orgId") Long var2, @QueryParam("domainName") String var3) {
      if(var1 == null) {
         throw new AppException(16, new Object[]{sm.getString("domain.id.is.null")});
      } else {
         RestUtils.checkNullParam(var2, "orgId", sm);
         RestUtils.checkNullParam(var3, "domainName", sm);
         String var4 = this.sc.getUserPrincipal().getName();
         String var5 = this.req.getRemoteAddr();
         return this.rsDomainMgr.pauseDomain(var1, var2, var3, var4, var5);
      }
   }

   @PUT
   @Path("restore")
   @RolesAllowed({"VMC-PLAT-ROLE_RSCLIENT"})
   public RsTaskMsg restoreDomain(@QueryParam("id") Long var1, @QueryParam("orgId") Long var2, @QueryParam("domainName") String var3) {
      if(var1 == null) {
         throw new AppException(16, new Object[]{sm.getString("domain.id.is.null")});
      } else {
         RestUtils.checkNullParam(var2, "orgId", sm);
         RestUtils.checkNullParam(var3, "domainName", sm);
         String var4 = this.sc.getUserPrincipal().getName();
         String var5 = this.req.getRemoteAddr();
         return this.rsDomainMgr.restoreDomain(var1, var2, var3, var4, var5);
      }
   }

   @PUT
   @Path("sleep")
   @RolesAllowed({"VMC-PLAT-ROLE_RSCLIENT"})
   public RsTaskMsg sleepDomain(@QueryParam("id") Long var1, @QueryParam("orgId") Long var2, @QueryParam("domainName") String var3) {
      if(var1 == null) {
         throw new AppException(16, new Object[]{sm.getString("domain.id.is.null")});
      } else {
         RestUtils.checkNullParam(var2, "orgId", sm);
         RestUtils.checkNullParam(var3, "domainName", sm);
         String var4 = this.sc.getUserPrincipal().getName();
         String var5 = this.req.getRemoteAddr();
         return this.rsDomainMgr.sleepDomain(var1, var2, var3, var4, var5);
      }
   }

   @PUT
   @Path("restart")
   @RolesAllowed({"VMC-PLAT-ROLE_RSCLIENT"})
   public RsTaskMsg restartDomain(@QueryParam("id") Long var1, @QueryParam("orgId") Long var2, @QueryParam("domainName") String var3) {
      if(var1 == null) {
         throw new AppException(16, new Object[]{sm.getString("domain.id.is.null")});
      } else {
         RestUtils.checkNullParam(var2, "orgId", sm);
         RestUtils.checkNullParam(var3, "domainName", sm);
         String var4 = this.sc.getUserPrincipal().getName();
         String var5 = this.req.getRemoteAddr();
         return this.rsDomainMgr.restartDomain(var1, var2, var3, var4, var5);
      }
   }

   @PUT
   @Path("/operateVm")
   @RolesAllowed({"VMC-PLAT-ROLE_RSCLIENT"})
   public void operateVm() {
      MultivaluedMap var1;
      QueryConfig var2 = RestUtils.queryParamToQueryInfo(var1 = this.uriInfo.getQueryParameters());
      Iterator var3 = var1.keySet().iterator();

      String var4;
      while(var3.hasNext()) {
         var4 = (String)var3.next();
         Long var5;
         if("orgId".equals(var4)) {
            var5 = ValidateParams.parseLong((String)var1.getFirst(var4), false, "org.id.value.error");
            var2.addRestriction(var4, var5);
         } else if("id".equals(var4)) {
            var5 = ValidateParams.parseLong((String)var1.getFirst(var4), false, "id.value.error");
            var2.addRestriction(var4, var5);
         } else if("userId".equals(var4)) {
            var5 = ValidateParams.parseLong((String)var1.getFirst(var4), false, "user.id.value.error");
            var2.addRestriction(var4, var5);
         }
      }

      String var6 = this.sc.getUserPrincipal().getName();
      var4 = this.req.getRemoteAddr();
      this.rsDomainMgr.operateVm(var6, var4, var2);
   }

   @GET
   @Path("snapshot/snapshotList")
   @RolesAllowed({"VMC-PLAT-ROLE_RSCLIENT"})
   public Response getDomainSnapshot(@QueryParam("id") Long var1, @QueryParam("orgId") Long var2) {
      if(var1 == null) {
         throw new AppException(16, new Object[]{sm.getString("domain.id.is.null")});
      } else if(var2 == null) {
         throw new AppException(16, new Object[]{sm.getString("org.id.value.error")});
      } else {
         List var3 = this.rsDomainMgr.querySnapshot(var1, var2);
         return Response.ok(new RsCommList(var3)).build();
      }
   }

   @GET
   @Path("snapshot/check")
   @RolesAllowed({"VMC-PLAT-ROLE_RSCLIENT"})
   public void checkSnapShotDomain(@QueryParam("orgId") Long var1, @QueryParam("vmId") Long var2, @QueryParam("snapshotName") String var3) {
      this.rsDomainMgr.checkSnapshot(var1, var2, var3);
   }

   @POST
   @Path("snapshot/")
   @RolesAllowed({"VMC-PLAT-ROLE_RSCLIENT"})
   public RsTaskMsg snapShotDomain(RsSnapshot var1) {
      if(var1 == null) {
         throw new AppException(16, new Object[]{sm.getString("domain.snapshot.is.null")});
      } else if(var1.getOrgId() == null) {
         throw new AppException(16, new Object[]{sm.getString("org.id.value.error")});
      } else if(var1.getVmId() == null) {
         throw new AppException(16, new Object[]{sm.getString("domain.id.is.null")});
      } else if(var1.getName() == null) {
         throw new AppException(16, new Object[]{sm.getString("domain.snapshot.name.is.null")});
      } else if(var1.getUserId() == null) {
         throw new AppException(16, new Object[]{sm.getString("user.id.is.null")});
      } else {
         this.rsDomainMgr.checkSnapshot(var1.getOrgId(), var1.getVmId(), var1.getName());
         String var2 = this.sc.getUserPrincipal().getName();
         String var3 = this.req.getRemoteAddr();
         RsTaskMsg var4 = new RsTaskMsg();
         Long var5 = this.rsDomainMgr.snapshotDomain(var1, var2, var3);
         var4.setMsgId(var5);
         return var4;
      }
   }

   @DELETE
   @Path("snapshot/deleteSnapshot")
   @RolesAllowed({"VMC-PLAT-ROLE_RSCLIENT"})
   public void deleteSnapShot() {
      MultivaluedMap var1;
      QueryConfig var2 = RestUtils.queryParamToQueryInfo(var1 = this.uriInfo.getQueryParameters());
      Iterator var3 = var1.keySet().iterator();

      String var4;
      while(var3.hasNext()) {
         var4 = (String)var3.next();
         Long var5;
         if("orgId".equals(var4)) {
            var5 = ValidateParams.parseLong((String)var1.getFirst(var4), false, "org.id.value.error");
            var2.addRestriction(var4, var5);
         } else if("id".equals(var4)) {
            var5 = ValidateParams.parseLong((String)var1.getFirst(var4), false, "id.value.error");
            var2.addRestriction(var4, var5);
         } else if("userId".equals(var4)) {
            var5 = ValidateParams.parseLong((String)var1.getFirst(var4), false, "user.id.value.error");
            var2.addRestriction(var4, var5);
         }
      }

      String var6 = this.sc.getUserPrincipal().getName();
      var4 = this.req.getRemoteAddr();
      this.rsDomainMgr.deleteSnapshot(var6, var4, var2);
   }

   @PUT
   @Path("snapshot/resume")
   @RolesAllowed({"VMC-PLAT-ROLE_RSCLIENT"})
   public void resumeFromSnapShot(RsSnapshot var1) {
      if(var1 == null) {
         throw new AppException(16, new Object[]{sm.getString("domain.snapshot.is.null")});
      } else if(var1.getVmId() == null) {
         throw new AppException(16, new Object[]{sm.getString("domain.id.is.null")});
      } else if(var1.getName() == null) {
         throw new AppException(16, new Object[]{sm.getString("domain.snapshot.name.is.null")});
      } else if(var1.getUserId() == null) {
         throw new AppException(16, new Object[]{sm.getString("user.id.is.null")});
      } else {
         String var2 = this.sc.getUserPrincipal().getName();
         String var3 = this.req.getRemoteAddr();
         this.rsDomainMgr.resumeFromSnapshot(var1, var2, var3);
      }
   }

   @DELETE
   @Path("delete")
   @RolesAllowed({"VMC-PLAT-ROLE_RSCLIENT"})
   public RsTaskMsg deleteDomain(@QueryParam("cloudId") Long var1, @QueryParam("id") Long var2, @QueryParam("name") String var3) {
      if(var2 != null && var1 != null) {
         String var4 = this.sc.getUserPrincipal().getName();
         String var5 = this.req.getRemoteAddr();
         return this.rsDomainMgr.deleteDomain(var2, var3, var1, var4, var5);
      } else {
         throw new AppException(15);
      }
   }

   @GET
   @RolesAllowed({"VMC-PLAT-ROLE_RSCLIENT"})
   public RsDomain getDomainInfo(@QueryParam("id") Long var1, @QueryParam("orgId") Long var2) {
      if(var1 != null && var2 != null) {
         return this.rsDomainMgr.queryDomainInfo(var1, var2);
      } else {
         throw new AppException(15);
      }
   }

   @GET
   @Path("vmio")
   @RolesAllowed({"VMC-PLAT-ROLE_RSCLIENT"})
   public Response getDomainIOTrend(@QueryParam("id") Long var1, @QueryParam("orgId") Long var2) {
      if(var1 != null && var2 != null) {
         return Response.ok(this.rsDomainMgr.queryDomainIOTrend(var1, var2)).build();
      } else {
         throw new AppException(15);
      }
   }

   @GET
   @Path("vmnetio")
   @RolesAllowed({"VMC-PLAT-ROLE_RSCLIENT"})
   public Response getDomainNetIOTrend(@QueryParam("id") Long var1, @QueryParam("orgId") Long var2) {
      if(var1 != null && var2 != null) {
         return Response.ok(this.rsDomainMgr.queryDomainNetIOTrend(var1, var2)).build();
      } else {
         throw new AppException(15);
      }
   }

   @GET
   @Path("vmcpu")
   @RolesAllowed({"VMC-PLAT-ROLE_RSCLIENT"})
   public Response getDomainCpuTrend(@QueryParam("id") Long var1, @QueryParam("orgId") Long var2) {
      if(var1 != null && var2 != null) {
         List var3 = this.rsDomainMgr.queryDomainCpuTrend(var1, var2);
         return Response.ok(new RsCommList(var3)).build();
      } else {
         throw new AppException(15);
      }
   }

   @GET
   @Path("vmmem")
   @RolesAllowed({"VMC-PLAT-ROLE_RSCLIENT"})
   public Response getDomainMemoryTrend(@QueryParam("id") Long var1, @QueryParam("orgId") Long var2) {
      if(var1 != null && var2 != null) {
         List var3 = this.rsDomainMgr.queryDomainMemoryTrend(var1, var2);
         return Response.ok(new RsCommList(var3)).build();
      } else {
         throw new AppException(15);
      }
   }

   @GET
   @Path("vmNetTrendMore")
   @RolesAllowed({"VMC-PLAT-ROLE_RSCLIENT"})
   public Response getDomainNetTrendMore(@QueryParam("id") Long var1, @QueryParam("startTimeLong") Long var2, @QueryParam("endTimeLong") Long var3, @QueryParam("userId") Long var4, @QueryParam("orgId") Long var5) {
      if(var1 != null && var5 != null && var4 != null && var3 != null && var2 != null) {
         List var6 = this.rsDomainMgr.queryDomainNetTrendMore(var1, var2, var3, var4, var5);
         return Response.ok(new RsCommList(var6)).build();
      } else {
         throw new AppException(15);
      }
   }

   @GET
   @Path("vmIOTrendMore")
   @RolesAllowed({"VMC-PLAT-ROLE_RSCLIENT"})
   public Response getDomainIOTrendMore(@QueryParam("id") Long var1, @QueryParam("startTimeLong") Long var2, @QueryParam("endTimeLong") Long var3, @QueryParam("userId") Long var4, @QueryParam("orgId") Long var5) {
      if(var1 != null && var5 != null && var4 != null && var3 != null && var2 != null) {
         List var6 = this.rsDomainMgr.queryDomainIOTrendMore(var1, var2, var3, var4, var5);
         return Response.ok(new RsCommList(var6)).build();
      } else {
         throw new AppException(15);
      }
   }

   @GET
   @Path("vmCpuTrendMore")
   @RolesAllowed({"VMC-PLAT-ROLE_RSCLIENT"})
   public Response getDomainCpuTrendMore(@QueryParam("id") Long var1, @QueryParam("startTimeLong") Long var2, @QueryParam("endTimeLong") Long var3, @QueryParam("userId") Long var4, @QueryParam("queryFld") String var5, @QueryParam("orgId") Long var6) {
      if(var1 != null && var6 != null && var4 != null && var3 != null && var2 != null && var5 != null) {
         List var7 = this.rsDomainMgr.queryDomainCpuMoreTrend(var1, var2, var3, var4, var6, var5);
         return Response.ok(new RsCommList(var7)).build();
      } else {
         throw new AppException(15);
      }
   }

   @PUT
   @Path("checkBackup")
   @RolesAllowed({"VMC-PLAT-ROLE_RSCLIENT"})
   public Response checkBackup(RsDomainForBackUp var1) {
      String var2 = this.a(var1);
      return Response.ok().header("errorCode", var2).build();
   }

   @PUT
   @Path("backup")
   @RolesAllowed({"VMC-PLAT-ROLE_RSCLIENT"})
   public Response backupDomain(RsDomainForBackUp var1) {
      RestUtils.checkNullParam(var1, "rsDomainForBackUp", sm);
      RestUtils.checkNullParam(var1.getId(), "vmId", sm);
      RestUtils.checkNullParam(var1.getUserId(), "userId", sm);
      RestUtils.checkNullParam(var1.getBackupMode(), "backupMode", sm);
      RestUtils.checkNullParam(var1.getStoreMode(), "storeMode", sm);
      RestUtils.checkNullParam(var1.getIp(), "userIp", sm);
      RestUtils.checkNullParam(var1.getAutoReplacement(), "autoReplacement", sm);
      String var2 = this.sc.getUserPrincipal().getName();
      String var3 = this.req.getRemoteAddr();
      String var4;
      if(StringUtils.isEmpty(var4 = this.a(var1))) {
         Long var6 = var1.getUserId();
         String var5 = this.rsDomainMgr.queryBackupPath(var1.getId());
         var5 = var5 + "/user_" + var6;
         var1.setDirectory(var5);
         var1.setStoreMode(Integer.valueOf(0));
         var1.setTmpDir("/vms/vmbackuptmp");
         this.rsDomainMgr.backupDomain(var6, var1, var2, var3);
         return Response.ok().build();
      } else {
         return Response.ok().header("errorCode", var4).build();
      }
   }

   @PUT
   @Path("restoreNew")
   @RolesAllowed({"VMC-PLAT-ROLE_RSCLIENT"})
   public RsTaskMsg restoreNew(@QueryParam("historyId") Long var1, @QueryParam("userIp") String var2) {
      String var3 = this.sc.getUserPrincipal().getName();
      String var4 = this.req.getRemoteAddr();
      BackupHistory var10 = this.backupHistoryMgr.queryById(var1);
      RsDomainForRestore var5;
      (var5 = new RsDomainForRestore()).setName(var10.getName());
      PublicCloud var6 = PublicCloudUtils.getPublicCloudByDomainId(var10.getDomainId(), this.domainMgr, this.publicCloudMgr);
      ModelData var7;
      if((var7 = (ModelData)this.domainHandler.queryDomainBasicInfoById(var6.getId(), var10.getDomainId()).getData()) != null && var7.get("id") != null) {
         String var8 = (String)var7.get("status");
         String var11 = (String)var7.get("title");
         if(var8 != null && ("running".equalsIgnoreCase(var8) || "paused".equalsIgnoreCase(var8))) {
            throw new AppException(2620);
         } else {
            var5.setEntryType("VIRTUAL_HOST");
            Long var12 = (Long)var7.get("hostId");
            var5.setVmName(var11);
            User var13 = this.userMgr.queryUserById(var10.getUserId());
            Long var9 = Long.valueOf(1L);
            Set var14;
            if(var13 != null && (var14 = var13.getUserGroups()) != null && var14.size() > 0) {
               var9 = ((UserGroup)var14.iterator().next()).getId();
            }

            StringBuilder var15;
            (var15 = new StringBuilder()).append("SELECT DOMAIN_ID FROM TBL_USER_VM WHERE (USER_ID = ").append(var10.getUserId()).append(" OR USER_GROUP_ID = ").append(var9).append(") AND DOMAIN_ID = ").append(var10.getDomainId());
            List var16;
            if((var16 = this.commonMgr.queryBySql(var15.toString())) != null && var16.size() != 0) {
               var5.setHostId(var12);
               var5.setType("cp");
               var8 = var10.getPath();
               var5.setDirectory(var8.substring(0, var8.lastIndexOf("/")));
               Date var17 = var10.getCreateTime();
               SimpleDateFormat var18 = new SimpleDateFormat("yyyyMMddHHmmss");
               if(var17 != null) {
                  var5.setTime(var18.format(var17));
               }

               return this.rsDomainMgr.restoreDomain(var10.getUserId(), var10.getDomainId(), var5, var3, "@VMC-RS", var4, var11, var10.getName(), var2);
            } else {
               throw new AppException(1001);
            }
         }
      } else {
         throw new AppException(1001);
      }
   }

   @GET
   @Path("domainPreName")
   @RolesAllowed({"VMC-PLAT-ROLE_RSCLIENT"})
   public Response queryDomainPreNameByOrgId(@QueryParam("orgId") Long var1) {
      ResponseBuilder var2;
      Organization var3;
      if((var3 = this.organizationMgr.queryOrgById(var1)) != null) {
         (var2 = Response.ok(var3)).header("result", var3.getDomainPreName());
         return var2.build();
      } else {
         (var2 = Response.ok()).header("result", "false");
         return var2.build();
      }
   }

   private String a(RsDomainForBackUp var1) {
      String var2 = "";
      Long var3 = var1.getUserId();
      Long var4 = var1.getId();
      Integer var5;
      if((var5 = var1.getAutoReplacement()) != null && var5.intValue() == 0 && !this.backupHandler.isAvailableForBackUp(var4, var3)) {
         var2 = "-2";
      }

      String var10;
      if(StringUtils.isNotEmpty(var10 = this.rsDomainMgr.queryBackupPath(var4))) {
         PublicCloud var6;
         if((var6 = PublicCloudUtils.getPublicCloudByDomainId(var4, this.domainMgr, this.publicCloudMgr)) != null) {
            Host var7 = this.hostMgr.queryHostByDomainId(var4.longValue());
            var10 = var10.substring(var10.lastIndexOf("/") + 1);
            BaseModelData var8;
            (var8 = new BaseModelData()).set("cloudId", var6.getId());
            var8.set("poolName", var10);
            var8.set("hostId", var7.getUniqueKey());
            Iterator var11 = this.storageHandler.queryStorePoolInfo(var8).getData().iterator();

            while(var11.hasNext()) {
               ModelData var12;
               String var13 = (String)(var12 = (ModelData)var11.next()).get("name");
               if("fcType".equals(var13)) {
                  String var9 = (String)var12.get("fcType");
                  if(!"fs".equals(var9)) {
                     var2 = "-5";
                     break;
                  }
               }

               Integer var14;
               if(this.storageSm.getString("storagePool.status").equals(var13) && (var14 = (Integer)var12.get("status")) != null && 0 == var14.intValue()) {
                  var2 = "-6";
                  break;
               }
            }

            (var8 = new BaseModelData()).set("cloudId", var6.getId());
            var8.set("id", var1.getId());
            if(this.domainHandler.isExistRawAndRunning(var8).booleanValue()) {
               var2 = "-3";
            }
         } else {
            var2 = "9007";
         }
      } else {
         var2 = "-1";
      }

      if(UserUtils.getUserVmType(this.userMgr, this.organizationMgr, var3, var4) == 0) {
         var2 = "-4";
      }

      return var2;
   }

   @PUT
   @Path("/antivirus")
   @RolesAllowed({"VMC-PLAT-ROLE_RSCLIENT"})
   public Response modifyAntivirus(@PathParam("domainId") long var1, @PathParam("enableAntivirus") int var3) {
      MultivaluedMap var8 = this.uriInfo.getQueryParameters();
      String var2 = this.sc.getUserPrincipal().getName();
      String var9 = this.req.getRemoteAddr();
      QueryConfig var4 = RestUtils.queryParamToQueryInfo(var8);
      Iterator var5 = var8.keySet().iterator();

      while(var5.hasNext()) {
         String var6 = (String)var5.next();
         Long var7;
         if("orgId".equals(var6)) {
            var7 = ValidateParams.parseLong((String)var8.getFirst(var6), false, "org.id.value.error");
            var4.addRestriction(var6, var7);
         } else if("domainId".equals(var6)) {
            var7 = ValidateParams.parseLong((String)var8.getFirst(var6), false, "domainId.value.error");
            var4.addRestriction(var6, var7);
         } else if("userId".equals(var6)) {
            var7 = ValidateParams.parseLong((String)var8.getFirst(var6), false, "user.id.value.error");
            var4.addRestriction(var6, var7);
         } else if("type".equals(var6)) {
            Integer var10 = ValidateParams.parseInt((String)var8.getFirst(var6), false, "type.value.error");
            var4.addRestriction(var6, var10);
         }
      }

      return Response.ok(String.valueOf(this.rsDomainMgr.configVmAntivirus(var2, var9, var4))).build();
   }

   @GET
   @Path("isExist")
   @RolesAllowed({"VMC-PLAT-ROLE_RSCLIENT"})
   public Response checkBackNameExist(@QueryParam("name") String var1, @QueryParam("vmId") String var2) {
      RestUtils.checkNullParam(var1, "name", sm);
      RestUtils.checkNullParam(var2, "vmId", sm);
      ResponseBuilder var3;
      (var3 = Response.ok(var1 = String.valueOf(this.rsDomainMgr.checkBackUpNameIsExist(var2, var1)))).header("result", var1);
      return var3.build();
   }

   @GET
   @Path("/antivirusConfigured")
   public Response checkAntivirusConfigured(@QueryParam("domainId") Long var1) {
      RestUtils.checkNullParam(var1, "domainId", sm);
      boolean var2 = this.rsDomainMgr.checkAntivirusConfigured(var1);
      return Response.ok().header("result", Boolean.valueOf(var2)).build();
   }

}
